clear all
clc
%problem definition
c=3e8; %speed of light
BW = 200e6; %bandwidth
fc = 77e9; % carrier frequency
%satisfy nyquist: F > max freq of FFT ~ 200khz
F = 589e3;
dt = 1/F;
samples = 34;
K = samples;
T = 0.001;
dfv = K*T;
N = K*T*F;
%T = dt*(N);
t = linspace(0,T*K,N);
samplelength = F*T; %length of each period
%   myPlot = figure(1)
%   set(myPlot,'Position',[200,200,400,250])

f_t = BW/2*sawtooth(t*2000*pi);
r1 = 8;
v1 = 22;
r2 = 113;
v2 = 17;
delay1 = 2*(r1+v1*t)/c;
delay2 = 2*(r2+v2*t)/c;
f_r1 = (BW/2).*sawtooth((t-delay1)*2000*pi)+2*v1*fc/c;
f_r2 = (BW/2).*sawtooth((t-delay2)*2000*pi)+2*v2*fc/c;
noise = rand(1,N)*j+rand(1,N);

%%% time domain signals
%subplot(2,1,1)
% plot(t*10^3,f_t/1e6,t*10^3,(f_r1+f_r2)/2e6,'+-')
% legend('Tx','Rx')
% xlabel('time [ms]');
% ylabel('frequency [MHz]');
% xlim([0,3])
% subplot(2,1,2)
% plot(t*10^3,f_t/1e6,t*10^3,(f_r1+f_r2)/2e6,'+-')
% %axis([-100e3,100e3,0,1e-3)]
% legend('Tx','Rx')
% xlabel('time [ms]');
% ylabel('frequency [MHz]');
% %xlim([0.992,1.004])
% %ylim([99,100.2])
% %legend('Tx','Rx')
% plot(t*10^3,f_t/1e6+(f_r1+f_r2)/2e6)

%modulation
offset = 0;
signal_t = cos(2*pi*(fc).*t+2*pi*cumsum(f_t)*dt+offset);
signal_r1 = cos(2*pi*fc.*(t-delay1)+2*pi*cumsum(f_r1)*dt+offset);
signal_r2 = cos(2*pi*fc.*(t-delay2)+2*pi*cumsum(f_r2)*dt+offset);
signal_r = (signal_r1+signal_r2)/2;

%mixing - normalized sgnal
mixed = (signal_t.* (signal_r)/2)/max(signal_t.* (signal_r)/2)+noise;

% 
myPlot = figure(2)
set(myPlot,'Position',[200,200,400,400])

mixed = fftshift(fft(mixed));

%fft the whole thing, get the 1d plot
%%hamming window
%mixed = mixed.*transpose(hamming(length(mixed)));

%%zero padding 
%mixed = [mixed zeros(1,9*length(mixed))];

%% 1D analysis
fspace = linspace(-F/2,F/2,length(mixed));
dbmix = 20*log10(abs(mixed));
subplot(2,1,1);
%plot(fspace/1000,dbmix1-max(dbmix1),fspace/1000,dbmix2-max(dbmix2))
plot(fspace/1000,dbmix-max(dbmix(length(mixed)/2+60:length(mixed))))
%legend('1','2')
xlabel('frequency [kHz]');
xlim([0,200]);
ylim([-50,0]);
title('A. Magnitude of FFT')
subplot(2,1,2);
phasefft = angle(mixed);
plot(fspace/1000,phasefft(1:length(mixed)));
xlabel('frequency [kHz]');
xlim([0,200]);
title('B. Phase of FFT')

% 
% % % % %now look at the 2d ffts... 
% % % % %in 'Two-dimensional signal processing in FMCW radars'
% % % % %take the 1D fft and wrap it, take the fft again. same as 2D Fft.
% % 
% mixedreshape = reshape(mixed(1:samples*samplelength),samples,samplelength);
% 
% %%hamming window
% for i = 1:samples
%    mixedreshape(i,:) = mixedreshape(i,:).*transpose(hamming(samplelength));
% end
% 
% %%zero padding 
% mixedreshape = [mixedreshape , zeros(samples,9*samplelength); zeros(10*samples,10* samplelength)];
% 
% treshaped = reshape(t(1:samples*samplelength),samples,samplelength);
% % myPlot = figure(1)
% % set(myPlot,'Position',[200,200,400,250])
% % kx = linspace(0,1,samplelength)
% % ky = linspace(1,samples,samples)
% % imagesc(kx, ky,mixedreshape)
% % set(gca, 'YDir', 'normal');
% % colorbar
% % xlabel('time within period, seconds')
% % ylabel('sample')
% 
% myPlot = figure(3)
% set(myPlot,'Position',[200,200,400,250])
% 
% mixed2d = fftshift(fft2(mixedreshape));
% % mixed1 = (fft(transpose(reshape(mixed,samples,samplelength))))
% % mixed2d = fftshift(fft(transpose(mixed2d)))
% 
% mixedplot = 20*log10(abs(mixed2d));
% %imagesc(kx, ky,mixedplot)
% 
% %range info dependent on sampling frequency F
% X = F*T*3e8/2/200e6;
% Y = 3e8/2/fc*samples/T%+5;
% 
% range = fliplr(linspace(-X/2,X/2,samplelength));
% %doppler = F*c/(2*fc);
% doppler = linspace(-Y/2,Y/2,samples);
% %doppler = transpose(Y);
% %doppler =  fliplr(3e8/2/77e9./(treshaped(:,1)*T));
% 
% imagesc(range, doppler,((mixedplot')),[max(max(mixedplot))-20, max(max(mixedplot))])
% set(gca, 'YDir', 'normal');
% 
% ylabel('Doppler (m/s)');
% xlabel('Range (m)');
% xlim([-150,150]);%
% ylim([0,30]);
% colorbar
