clear 
%problem definition
c=3e8 %speed of light
N = 2^16 % number of points
F = .2e6% frequency for undersampling - only want to see peak at 200kHz, max
%good: N = 2^16, F = 1000e3
dt = 1/F;
fc = 200e6
fm = 8620;
deltaf = 2e3;
r = 15e3;
v = 370.8;
T = 23.2e-3;
fd = 2*v/c*fc;

N = floor(T/dt);
t = linspace(0,T,N);

%modulation index
beta = deltaf/fm;
delay = 2*(r+v*t)/c;

f_t = deltaf*cos(2*pi*fm*t);
f_r = deltaf*cos(2*pi*fm*(t-delay));%+fd;
st = exp(j*deltaf/fm*sin(2*pi*fm*t));
sr = exp(j*(-2*pi*fc*delay + deltaf/fm*sin(2*pi*fm*(t-delay))));
offset = 0;
s_t = cos(2*pi*(fc).*t+2*pi*cumsum(f_t)*dt+offset);
s_r = cos(2*pi*fc.*(t-delay)+2*pi*cumsum(f_r)*dt+offset);
noise = rand(1,N)*j+j*rand(1,N);

%mixing
mixed = conj(s_t).*s_r/2;
mixed = mixed/max(mixed);%+noise/3;

 myPlot = figure(1)
 set(myPlot,'Position',[200,200,400,400])


subplot(2,1,1)
plot(t*10^3,f_t/1e3,t*10^3,(f_r)/1e3,'+-')
legend('Tx','Rx')
xlabel('time [ms]');
ylabel('frequency [kHz]');
xlim([0,.4])
%ylim([0,3])
subplot(2,1,2)
plot(t*10^3,f_t/1e3,t*10^3,(f_r)/1e3,'+-')
%axis([-100e3,100e3,0,1e-3)]
legend('Tx','Rx')
xlabel('time [ms]');
ylabel('frequency [kHz]');
ylim([1.8,2.5])
xlim([1.4,1.6])
legend('Tx','Rx')


%%hamming window
mixed = mixed.*transpose(hamming(length(mixed)));

%%zero padding 
mixed = [mixed zeros(1,9*length(mixed))];

%mixed = mixed.*cos(2*pi*fc*t); %downconvert
%fft the whole thing, get the 1d plot
%D = 2*deltaf/fm*sin(2*pi*fm*r/c);
%fd = 2*v/c*fc;
%ud = besselj(0,D).*exp(j*2*pi*fd*t)+besselj(1,D).*exp(j*2*pi*fd*t+j*2*pi*fm*(t-r/c))+besselj(1,D)*exp(j*2*pi*fd*t-j*2*pi*fm.*(t-r/c));
%udd = exp(j*2*pi*fd*t);
%udu = exp(j*2*pi*fd*t+j*2*pi*fm*(t-r/c));
%udl = exp(j*2*pi*fd*t-j*2*pi*fm*(t-r/c));
% fNorm = 0.33;
% [b,a] = butter(10, fNorm, 'low');
% mixed_filtered= filtfilt(b, a, mixed);
% 
%ud = [ud zeros(1,3*length(ud))]


 myPlot = figure(2)
 set(myPlot,'Position',[200,200,400,400])

mixed1d = fftshift(fft(mixed));
fspace = linspace(-F/2,F/2,N*10);
dbmix = 20*log10(abs(mixed1d));
%dbmix2 =20*log10(abs(fftshift(fft(ud))));
subplot(2,1,1);
plot(fspace/1000,dbmix-max(dbmix))%,fspace/1000,dbmix2);
xlabel('frequency [kHz]');
xlim([-10,10]);
title('A. Magnitude of FFT')
subplot(2,1,2);
phasefft = unwrap(phase(mixed1d));
%phase2fft = unwrap(angle(fftshift(fft(ud))));
plot(fspace/1000,(phasefft))%,fspace/1000,(phase2fft));
xlabel('frequency [kHz]');
ylabel('phase [rad]');
xlim([-10,10]);
title('B. Phase of FFT')


% %back of the envelope calculations
% doppler = ud(2331);
% upper = ud(2531);
% lower = ud(2131);
% X = lower* conj(doppler);
% Xtest = exp(j*2*pi*fm*r/c);
% Tactual = 2/(2*pi*fm)*atan(imag(X)/real(X))
% Ttest = 2/(2*pi*fm)*atan(imag(Xtest)/real(Xtest))
% rtest = 3e8/(4*pi*fm)*atan(imag(Xtest)/real(Xtest))
% T0 = 2*r/c;
% 
%fspacecheck = [fspace(10125) fspace(9325)]
%angle1 = phasefft(10125) -phasefft(9325)
fspacecheck = [fspace(2532) fspace(2132)]
angle1 = phasefft(2532) -phasefft(2132)
%phasedif = 2*pi*fm*r/c
calculatedr = -angle1*c/(fm*pi*2)*2

