clear 
%problem definition
c=3e8 %speed of light
BW = 200e6 %bandwidth
fc = 77e9 % carrier frequency
N = 2^16 % number of points
F = 180e3 % frequency for undersampling - only want to see peak at 200kHz, max
%good: N = 2^16, F = 1000e3
dt = 1/F;
samples = 1
T = samples*0.001
%N = T/dt+1
%T = dt*(N-1);
%samples = floor(T/0.001); %number of modulation periods being looked at
t = linspace(0,T,N);
samplelength = floor(length(t)/samples); %length of each period

 myPlot = figure(2)
 set(myPlot,'Position',[200,200,400,400])

f_t = BW/2*sawtooth(t*2000*pi,0.5);
r1 = 15;
v1 = 87;
%r2 = 30;
%v2 = -87;
delay1 = 2*(r1+v1*t)/c;
%delay2 = 2*(r2+v2*t)/c;
f_r1 = (BW/2).*sawtooth((t-delay1/2)*2000*pi,0.5)+2*v1*fc/c;
noise = rand(1,N)+rand(1,N)*j;

% subplot(2,1,1)
% plot(t*10^3,f_t/1e6,t*10^3,(f_r1)/1e6,'+-')
% legend('Tx','Rx')
% xlabel('time [ms]');
% ylabel('frequency [MHz]');
% xlim([0,3])
% ylim([-100,100])
% subplot(2,1,2)
% plot(t*10^3,f_t/1e6,t*10^3,(f_r1)/1e6,'+-')
% %axis([-100e3,100e3,0,1e-3)]
% legend('Tx','Rx')
% xlabel('time [ms]');
% ylabel('frequency [MHz]');
% xlim([0.4995,.5005])
% ylim([99.94,100.1])
% %legend('Tx','Rx')

% 
% plot(t*10^3,f_t/1e6,t*10^3,f_r1/1e6,'o-');
% xlabel('time [ms]');
% ylabel('frequency [MHz]');
% legend('Tx','Rx')
% xlim([0,2])
% plot(t*10^3,( f_r1-f_t)/10^3)
% %axis([-100e3,100e3,0,1e-3)]
% xlabel('time [ms]');
% ylabel('frequency [kHz]');
% xlim([0,2])

%modulation
phase = 0;
signal_t = cos(2*pi*(fc).*t+2*pi*cumsum(f_t)*dt+phase);
signal_r1 = cos(2*pi*fc.*(t-delay1)+2*pi*cumsum(f_r1)*dt+phase);

%mixing
mixed = signal_t.* (signal_r1)/2;
mixed = mixed/max(mixed)+ noise;

%fft the whole thing, get the 1d plot
%%hamming window
mixed = mixed.*transpose(hamming(length(mixed)));

%%zero padding 
mixed = [mixed zeros(1,9*length(mixed))];

myPlot = figure(1)
 set(myPlot,'Position',[200,200,400,400])

%mixed1d = fftshift(fft(mixed))
mixed1d = fftshift(fft(mixed));
fspace = linspace(-F/2,F/2,10*N);
dbmix = 20*log10(abs(mixed1d));
subplot(2,1,1);
plot(fspace/1000,dbmix-max(dbmix(5*N+50:end)))
xlabel('frequency [kHz]');
xlim([0,80]);
ylim([-50,0]);
title('A. Magnitude of FFT')
subplot(2,1,2);
phasefft = angle(mixed1d);
plot(fspace/1000,phasefft);
xlabel('frequency [kHz]');
xlim([0,80]);5
title('B. Phase of FFT')

fup = 2*v1*77e9/3e8+BW/0.001*2*r1/3e8
fdn = 2*v1*77e9/3e8-BW/0.001*2*r1/3e8
fd = 2*v1*77e9/3e8
fother = BW/0.001*2*r1/3e8